import javax.swing.filechooser.*;
import java.io.*;

/**
 * Filtrerar filerna i en fildialogruta
 * @author Pr Thernstrm
 */
class LogFileFilter extends javax.swing.filechooser.FileFilter {
    
    String filndelse;
    String beskrivning;
    
    LogFileFilter(String filndelse, String beskrivning) {
        
        this.filndelse = filndelse;
        this.beskrivning = beskrivning;
        
    }
    
    /**
     * Kolla om en fil r godknd att visas i fillistan
     * @param f Referens till en fil
     */
    public boolean accept(File f) {        
        return f.isDirectory() || f.getName().toLowerCase().endsWith(filndelse);
    }
    
    /**
     * Beskrivning av denna filtrering
     * @return Beskrivning
     */
    public String getDescription() {        
        return beskrivning;        
    }

}