import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.*;

/**
 * Loggvisarens grnssnitt
 */
public class LoggGUI extends JFrame implements ActionListener, MouseListener, KeyListener {
    
    // variabler som behvs
    Loggfil loggfilen = new Loggfil();
    
    private final String PROGRAMNAMN = "Windows XP Firewall Log Viewer";
    private final String PROGRAMVERSION = "0.2";
    
    // Grafiska komponenter till huvudfnstret
    
    // MENYN
    JMenuBar meny = new JMenuBar();
    JMenu menyFil = new JMenu("File");
    JMenuItem menyFilppna = new JMenuItem("Open...", new ImageIcon(ClassLoader.getSystemResource("ikoner/Open16.gif") ));
    JMenuItem menyFilUppdatera = new JMenuItem("Refresh", new ImageIcon(ClassLoader.getSystemResource("ikoner/Refresh16.gif")) );
    JMenuItem menyFilAvsluta = new JMenuItem("Quit");
    JMenu menyHjlp = new JMenu("Help");
    JMenuItem menyHjlpOm = new JMenuItem("About", new ImageIcon(ClassLoader.getSystemResource("ikoner/About16.gif")));
    
    // TOOLBAR
    JToolBar verktygsrad = new JToolBar("Log File Viewer");
    JLabel verktygsradLabelLoggfil = new JLabel("Log file ");
    JTextField verktygsradLoggfil = new JTextField("No log file opened.", 25);
    JButton verktygsradVljFil = new JButton("Open...", new ImageIcon(ClassLoader.getSystemResource("ikoner/Open16.gif")));
    JButton verktygsradUppdatera = new JButton("Refresh", new ImageIcon(ClassLoader.getSystemResource("ikoner/Refresh16.gif")));
    JButton btnTest = new JButton("Jag r en testknapp.");
    
    // TABBARNA
    JTabbedPane tabbar = new JTabbedPane();
    JPanel tabbarPanel1 = new JPanel(new BorderLayout());
    JPanel tabbarPanel2 = new JPanel(new GridLayout(2,2));
    // tab 1
    JTable tabell1 = new JTable(new LoggfilTableModel(loggfilen));
    JScrollPane tabell1SP = new JScrollPane(tabell1);
    // tab 1 - info lngst ner
    JPanel tabbarTab1InfoPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
    JLabel tabbarTab1InfoPanelInfotextDROP = new JLabel("dropped packets");
    JLabel tabbarTab1InfoPanelInfotextDROPruta = new JLabel("    ");
    JLabel tabbarTab1InfoPanelInfotextSUCCESSFUL = new JLabel("successful connections");
    JLabel tabbarTab1InfoPanelInfotextSUCCESSFULruta = new JLabel("    ");
    JLabel tabbarTab1InfoPanelLblStreck = new JLabel("");
    JTextField tabbarTab1InfoPanelTxtFiltrera = new JTextField("", 15);
    JRadioButton tabbarTab1InfoPanelRadioAnd = new JRadioButton("And", true);
    JRadioButton tabbarTab1InfoPanelRadioOr = new JRadioButton("Or");
    ButtonGroup tabbarTab1InfoPanelRadioGroup = new ButtonGroup();
    JToggleButton tabbarTab1InfoPanelBtnFiltrera = new JToggleButton("Filter");
    //JLabel tabbarTab1InfoPanelLblInfo = new JLabel(new ImageIcon("ikoner/Information16.gif"));
    JButton tabbarTab1InfoPanelLbtnInfo = new JButton(new ImageIcon("ikoner/Information24.gif"));
    
    // tab 2 - tabeller med statistik
    JTable tabbarTab2Tabell1 = new JTable(5,2);
    JScrollPane tabbarTab2Tabell1SP = new JScrollPane(tabbarTab2Tabell1);
    JTable tabbarTab2Tabell2 = new JTable(5,2);
    JScrollPane tabbarTab2Tabell2SP = new JScrollPane(tabbarTab2Tabell2);
    JTable tabbarTab2Tabell3 = new JTable(5,2);
    JScrollPane tabbarTab2Tabell3SP = new JScrollPane(tabbarTab2Tabell3);
    JTable tabbarTab2Tabell4 = new JTable(5,2);
    JScrollPane tabbarTab2Tabell4SP = new JScrollPane(tabbarTab2Tabell4);
    
    Container c = getContentPane();
    
    LoggGUI() {
        
        // MENYN
        setJMenuBar(meny);
        meny.add(menyFil);
        menyFil.add(menyFilppna);
        menyFil.add(menyFilUppdatera);
        menyFil.addSeparator();
        menyFil.add(menyFilAvsluta);
        meny.add(menyHjlp);
        menyHjlp.add(menyHjlpOm);
        menyFilUppdatera.setEnabled(false);
        // stt kortkommandon
        menyFilppna.setAccelerator(KeyStroke.getKeyStroke( KeyEvent.VK_O, 2 ) );
        menyFilUppdatera.setAccelerator(KeyStroke.getKeyStroke( KeyEvent.VK_R, 2 ) );
        menyFilAvsluta.setAccelerator(KeyStroke.getKeyStroke( KeyEvent.VK_ESCAPE, 0 ) );
        menyFilppna.setMnemonic(KeyEvent.VK_O);
        menyFilUppdatera.setMnemonic(KeyEvent.VK_R);
        menyFilAvsluta.setMnemonic(KeyEvent.VK_Q);
        menyFil.setMnemonic(KeyEvent.VK_F);
        menyHjlp.setMnemonic(KeyEvent.VK_H);
        menyHjlpOm.setMnemonic('A');
        menyHjlpOm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1, 0));
        // stt lyssnare
        menyFilAvsluta.addActionListener(this);
        menyHjlpOm.addActionListener(this);
        menyFilppna.addActionListener(this);
        menyFilUppdatera.addActionListener(this);
        
        // TOOLBAR
        c.add(verktygsrad, BorderLayout.NORTH);
        verktygsrad.add(verktygsradLabelLoggfil);
        verktygsrad.add(verktygsradLoggfil);
        verktygsrad.addSeparator();
        verktygsrad.add(verktygsradVljFil);
        verktygsrad.addSeparator();
        verktygsrad.add(verktygsradUppdatera);
        verktygsradUppdatera.setEnabled(false);
        verktygsrad.addSeparator();
        verktygsradLoggfil.setEditable(false);
        verktygsradVljFil.addActionListener(this);
        verktygsradUppdatera.addActionListener(this);
        //verktygsrad.add(btnTest);
        btnTest.addActionListener(this);
        // tooltips
        verktygsradVljFil.setToolTipText("Open (Ctrl + O)");
        verktygsradUppdatera.setToolTipText("Refresh (Ctrl + R)");
        // mneomics (h, hur det nu stavas :/ )
        verktygsradVljFil.setMnemonic('O');
        verktygsradUppdatera.setMnemonic('R');
        
        // TABBARNA
        c.add(tabbar);
        //tabbar.setBorder(new EmptyBorder(0, 0, 5, 0));
        // tab 1
        tabbar.addTab("View log file", tabbarPanel1);
        tabbarPanel1.add(tabell1SP, BorderLayout.CENTER);
        tabell1.setGridColor(new Color(200,200,200)); // fr mrka som default tycker jag
        tabell1.setAutoResizeMode(JTable.AUTO_RESIZE_OFF); // inge scrollbar i sidled annars
        tabell1.getTableHeader().addMouseListener(this);  // lyssna efter musklick
        tabell1.setAutoCreateColumnsFromModel(false); // t.ex. bakgrundsfrgen mlas inte
        // stt TableCellRenderer p alla kolumner (finns det nt smartare stt n detta?)
        for (int i = 0; i < tabell1.getColumnCount(); i++) {
            tabell1.getColumnModel().getColumn(i).setCellRenderer(new LoggfilTableCellRenderer());
        }
        tabell1.getColumnModel().getColumn(0).setHeaderValue("No. v");
        tabell1.getColumnModel().getColumn(1).setHeaderValue("Date/Time");
        tabell1.getColumnModel().getColumn(2).setHeaderValue("Action");
        tabell1.getColumnModel().getColumn(3).setHeaderValue("Protocol");
        tabell1.getColumnModel().getColumn(4).setHeaderValue("Source IP");
        tabell1.getColumnModel().getColumn(5).setHeaderValue("Destination IP");
        tabell1.getColumnModel().getColumn(6).setHeaderValue("src port");
        tabell1.getColumnModel().getColumn(7).setHeaderValue("dst port");
        tabell1.getColumnModel().getColumn(8).setHeaderValue("Size");
        tabell1.getColumnModel().getColumn(9).setHeaderValue("tcpflags");
        tabell1.getColumnModel().getColumn(10).setHeaderValue("tcpsyn");
        tabell1.getColumnModel().getColumn(11).setHeaderValue("tcpack");
        tabell1.getColumnModel().getColumn(12).setHeaderValue("tcpwin");
        tabell1.getColumnModel().getColumn(13).setHeaderValue("icmptype");
        tabell1.getColumnModel().getColumn(14).setHeaderValue("icmpcode");
        tabell1.getColumnModel().getColumn(15).setHeaderValue("info");
        tabell1.getColumnModel().getColumn(16).setHeaderValue("path");
        // tab 1 - infopanel
        tabbarPanel1.add(tabbarTab1InfoPanel, BorderLayout.SOUTH);
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelInfotextDROPruta);
        tabbarTab1InfoPanelInfotextDROPruta.setBackground(LoggfilGrafik.getColorBakgrundDROP());
        tabbarTab1InfoPanelInfotextDROPruta.setOpaque(true);
        tabbarTab1InfoPanelInfotextDROPruta.setBorder( BorderFactory.createLineBorder(Color.GRAY) );
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelInfotextDROP);
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelInfotextSUCCESSFULruta);
        tabbarTab1InfoPanelInfotextSUCCESSFULruta.setBackground(LoggfilGrafik.getColorBakgrundSUCCESSFUL());
        tabbarTab1InfoPanelInfotextSUCCESSFULruta.setOpaque(true);
        tabbarTab1InfoPanelInfotextSUCCESSFULruta.setBorder( BorderFactory.createLineBorder(Color.GRAY) );
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelInfotextSUCCESSFUL);
        tabbarTab1InfoPanelLblStreck.setPreferredSize(new Dimension(16,28));
        tabbarTab1InfoPanelLblStreck.setBorder( BorderFactory.createCompoundBorder(new EmptyBorder(0,8,0,6), BorderFactory.createCompoundBorder(BorderFactory.createMatteBorder(0,1,0,0, Color.GRAY ), BorderFactory.createMatteBorder(0,1,0,0, Color.WHITE) ) ));
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelLblStreck);
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelTxtFiltrera);
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelRadioAnd);
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelRadioOr);
        tabbarTab1InfoPanelRadioGroup.add(tabbarTab1InfoPanelRadioAnd);
        tabbarTab1InfoPanelRadioGroup.add(tabbarTab1InfoPanelRadioOr);
        tabbarTab1InfoPanel.add(tabbarTab1InfoPanelBtnFiltrera);
        tabbarTab1InfoPanelLbtnInfo.setBorder(BorderFactory.createEmptyBorder());
        tabbarTab1InfoPanelBtnFiltrera.addActionListener(this);
        tabbarTab1InfoPanelRadioAnd.addActionListener(this);
        tabbarTab1InfoPanelRadioOr.addActionListener(this);
        // tooltips
        tabbarTab1InfoPanelTxtFiltrera.addKeyListener(this);
        tabbarTab1InfoPanelTxtFiltrera.setToolTipText("Enter words, separated by space.");
        tabbarTab1InfoPanelRadioAnd.setToolTipText("Only show rows with ALL words");
        tabbarTab1InfoPanelRadioOr.setToolTipText("Show rows with any of the words");
        tabbarTab1InfoPanelBtnFiltrera.setToolTipText("Start/Stop filtering the table");
        tabbarTab1InfoPanelBtnFiltrera.setMnemonic('F');
        
        // tab 2
        tabbar.addTab("Statistics", tabbarPanel2);
        tabbarPanel2.add(tabbarTab2Tabell1SP);
        tabbarPanel2.add(tabbarTab2Tabell2SP);
        tabbarPanel2.add(tabbarTab2Tabell3SP);
        tabbarPanel2.add(tabbarTab2Tabell4SP);
        tabbarTab2Tabell1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tabbarTab2Tabell2.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tabbarTab2Tabell3.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tabbarTab2Tabell4.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tabbarTab2Tabell1.setGridColor(new Color(200,200,200));
        tabbarTab2Tabell2.setGridColor(new Color(200,200,200));
        tabbarTab2Tabell3.setGridColor(new Color(200,200,200));
        tabbarTab2Tabell4.setGridColor(new Color(200,200,200));
        // weha! vm i borderskapning?? =)
        tabbarTab2Tabell1SP.setBorder( BorderFactory.createCompoundBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(10,10,10,10), BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder() ,"Source IP frequency")), BorderFactory.createEmptyBorder(5,10,10,10)) );
        tabbarTab2Tabell2SP.setBorder( BorderFactory.createCompoundBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(10,10,10,10), BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder() ,"Destination IP frequency")), BorderFactory.createEmptyBorder(5,10,10,10)) );
        tabbarTab2Tabell3SP.setBorder( BorderFactory.createCompoundBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(10,10,10,10), BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder() ,"Source Port frequency")), BorderFactory.createEmptyBorder(5,10,10,10)) );
        tabbarTab2Tabell4SP.setBorder( BorderFactory.createCompoundBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(10,10,10,10), BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder() ,"Destination Port frequency")), BorderFactory.createEmptyBorder(5,10,10,10)) );
        
        // INITIERA
        initiera();
        
        // PACKA OCH VISA
        // nskade storlekar (fnstret kan t.ex. bli strre n skrmen om jag inte stter detta!
        tabbar.setPreferredSize(new Dimension(900, 600));
        setTitle(PROGRAMNAMN);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        pack();
        // placera fnster i mitten p skrmen
        setLocation( (Toolkit.getDefaultToolkit().getScreenSize().width/2) -  this.getWidth()/2, (Toolkit.getDefaultToolkit().getScreenSize().height/2) -  this.getHeight()/2   );
        setVisible(true);
        
    }
    
    
    /** Main-metod. Skapar en ny LoggGUI.
     * @param args inget ...
     */
    public static void main(String[] args) {
        LoggGUI myLogg = new LoggGUI();
    }
    
    /** Hndelse har intrffat
     * @param e ActionEvent
     */
    public void actionPerformed(ActionEvent e) {
        
        // radiobutton: bda
        if ( (e.getSource() == tabbarTab1InfoPanelRadioAnd) || (e.getSource() == tabbarTab1InfoPanelRadioOr) ) {
            filtreraTabell();
        }
        
        // knapp: filtrera
        if (e.getSource() == tabbarTab1InfoPanelBtnFiltrera) {
            filtreraTabell();
        }
        
        if (e.getSource() == btnTest) {
        }
        
        // Knapp: ppna eller menyval ppna
        if ((e.getSource() == verktygsradVljFil) || (e.getSource()== menyFilppna)) {
            vljOchVisaFil();
        }
        
        // knapp: Refresh
        if ((e.getSource() == verktygsradUppdatera) || (e.getSource() == menyFilUppdatera) ) {
            laddaOmFilen();
        }
        
        // meny: Quit
        if (e.getSource() == menyFilAvsluta) {
            avsluta();
        }
        
        // meny: About
        if (e.getSource() == menyHjlpOm) {
            JOptionPane.showMessageDialog(this,
                    PROGRAMNAMN
                    + "\nversion " + PROGRAMVERSION + " (compiled january 8, 2005)"
                    + "\n\nWritten by Pr Thernstrm, as part of the course \n"
                    + "\"Programkonstruktion i Java\" at Mid Sweden University"
                    + "\n\n"
                    + "E-mail: par.thernstrom@gmail.com\n"
                    + "URL: http://eskapism.se/software/?page=xplog"
                    
                    );
        }
        
    }
    
    /**
     * Uppdaterar:
     * <br>Antal DROP och SUCCESSFUL
     */
    public void uppdateraStatus() {
        
        // antal, de olika frgare labelnarna
        tabbarTab1InfoPanelInfotextDROP.setText( loggfilen.getAntalDrop() + " dropped packets");
        tabbarTab1InfoPanelInfotextSUCCESSFUL.setText( loggfilen.getAntalSucess() + " successful connections");
        
    }
    
    /**
     * Initierar fnstret
     * <br>Bl.a. s grs ett frsk att ladda loggfilen frn c:\windows\pfirewall.log
     */
    public void initiera() {
        
        setCursor( new Cursor(Cursor.WAIT_CURSOR));
        
        loggfilen.setSkvg("c:\\windows\\pfirewall.log");
        if (loggfilen.laddaLoggfil()) {
            // loggfilen lstes in
            verktygsradLoggfil.setText( loggfilen.getSkvg() );
            verktygsradUppdatera.setEnabled(true);
            menyFilUppdatera.setEnabled(true);
            uppdateraStatus();
            packaKolumner();
            skapaStatistik();
        } else {
            verktygsradLoggfil.setText( "Could not load \"" + loggfilen.getSkvg() + "\"" );
            uppdateraStatus();
        }
        setCursor( new Cursor(Cursor.DEFAULT_CURSOR));
    }
    
    /**
     * Packar ihop alla kolumner
     */
    public void packaKolumner() {
        // packa dr
        for (int i = 0; i < tabell1.getColumnCount(); i++) {
            packColumn(tabell1, i, 4);
        }
    }
    
    /** "Packar ihop" en kolumn s den blir minst lika bred som innehllet i den
     * <br>Mycket inspierad av: http://javaalmanac.com/egs/javax.swing.table/PackCol.html
     * @param table Tabellen som innehller kolumnen som ska packas ihop
     * @param vColIndex id-nr p kolumn som ska sorteras
     * @param margin Hur stor marginal det ska bli runt packning
     */
    public void packColumn(JTable table, int vColIndex, int margin) {
        TableModel model = table.getModel();
        DefaultTableColumnModel colModel = (DefaultTableColumnModel)table.getColumnModel();
        TableColumn col = colModel.getColumn(vColIndex);
        int width = 0;
        
        // Get width of column header
        TableCellRenderer renderer = col.getHeaderRenderer();
        if (renderer == null) {
            renderer = table.getTableHeader().getDefaultRenderer();
        }
        Component comp = renderer.getTableCellRendererComponent(
                table, col.getHeaderValue(), false, false, 0, 0);
        width = comp.getPreferredSize().width;
        
        // Get maximum width of column data
        for (int r=0; r<table.getRowCount(); r++) {
            renderer = table.getCellRenderer(r, vColIndex);
            comp = renderer.getTableCellRendererComponent(
                    table, table.getValueAt(r, vColIndex), false, false, r, vColIndex);
            width = Math.max(width, comp.getPreferredSize().width);
        }
        
        // Add margin
        width += 2*margin;
        
        // Set the width
        col.setPreferredWidth(width);
    }
    
    
    //public void sortAllRowsBy(DefaultTableModel model, int colIndex, boolean ascending) {
    //public void sortAllRowsBy(LoggfilTableModel model, int colIndex, boolean ascending) {
    /** Sorterar en kolumn i en tabell och ser till att alla andra kolumers rader ndras
     * drefter (s att raderna r "synkade" liksom")
     * @param model Den TableModel som ska sorteras
     * @param colIndex Kolumn som ska sorteras
     * @param ascending Anger sorteringens riktning
     */
    public void sortAllRowsBy(LoggfilTableModel model, int colIndex, boolean ascending) {
        Vector data = model.getDataVector();
        Collections.sort(data, new ColumnSorter(colIndex, ascending));
        model.fireTableStructureChanged();
    }
    
    /** Sorterar en kolumn i en tabell och ser till att alla andra kolumers rader ndras
     * drefter (s att raderna r "synkade" liksom")
     * <br>Vldigt lik sortAllRowsBy ...
     * @param model Den TableModel som ska sorteras
     * @param colIndex Kolumn som ska sorteras
     * @param ascending Anger sorteringens riktning
     */
    public void sorteraStatistikTabell(DefaultTableModel model, int colIndex, boolean ascending) {
        Vector data = model.getDataVector();
        Collections.sort(data, new ColumnSorter(colIndex, ascending));
        model.fireTableStructureChanged();
    }
    
    
    /** om musklick sker ...
     * @param e MouseEvent
     */
    public void mouseClicked(MouseEvent e) {
        
        String s;
        int kolumn;
        
        if (e.getButton() == 1) {
            kolumn = tabell1.getTableHeader().columnAtPoint(  e.getPoint()  ); // ger numret p den kolumn som ska sorteras
            sorteraKolumn(kolumn);
        }
    }
    
    /** Anvnds inte
     * @param e MouseEvent
     */
    public void mouseEntered(MouseEvent e) {
    }
    
    /** Anvnds inte
     * @param e MouseEvent
     */
    public void mouseExited(MouseEvent e) {
    }
    
    /** Anvnds inte
     * @param e MouseEvent
     */
    public void mousePressed(MouseEvent e) {
    }
    
    /** Anvnds inte
     * @param e MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
    }
    
    /**
     * Sorterar en kolumn
     * <br>Denna kod frn:
     * http://javaalmanac.com/egs/javax.swing.table/Sorter.html
     */
    // This comparator is used to sort vectors of data
    public class ColumnSorter implements Comparator {
        int colIndex;
        boolean ascending;
        ColumnSorter(int colIndex, boolean ascending) {
            this.colIndex = colIndex;
            this.ascending = ascending;
        }
        /** Jmfr tv objekt
         * @param a Frsta objektet som ska jmfras mot ...
         * @param b ... det andra objektet
         * @return Vet inte riktigt... hgt nummer om a r jmfrbart strre n b?
         */
        public int compare(Object a, Object b) {
            Vector v1 = (Vector)a;
            Vector v2 = (Vector)b;
            Object o1 = v1.get(colIndex);
            Object o2 = v2.get(colIndex);
            
            // Treat empty strains like nulls
            if (o1 instanceof String && ((String)o1).length() == 0) {
                o1 = null;
            }
            if (o2 instanceof String && ((String)o2).length() == 0) {
                o2 = null;
            }
            
            // Sort nulls so they appear last, regardless
            // of sort order
            if (o1 == null && o2 == null) {
                return 0;
            } else if (o1 == null) {
                return 1;
            } else if (o2 == null) {
                return -1;
            } else if (o1 instanceof Comparable) {
                if (ascending) {
                    return ((Comparable)o1).compareTo(o2);
                } else {
                    return ((Comparable)o2).compareTo(o1);
                }
            } else {
                if (ascending) {
                    return o1.toString().compareTo(o2.toString());
                } else {
                    return o2.toString().compareTo(o1.toString());
                }
            }
        }
    }
    
    /**
     * Visar en fildialog dr anvndaren fr vlja loggfil att visa.
     * <br>Vljs en fil laddas denna och visas i tabellen.
     */
    public void vljOchVisaFil() {
        
        setCursor( new Cursor(Cursor.WAIT_CURSOR));
        
        // vlj fil
        JFileChooser filvljare = new JFileChooser("c:\\windows\\");
        filvljare.addChoosableFileFilter( new LogFileFilter(".log","Log files (*.log)") );
        filvljare.addChoosableFileFilter( new LogFileFilter("pfirewall.log","Windows XP Firewall Log File (pfirewall.log)") );
        int filvljareSvar = filvljare.showOpenDialog(this);
        
        switch (filvljareSvar) {
            case JFileChooser.CANCEL_OPTION:
                break;
            case JFileChooser.ERROR_OPTION:
                break;
            case JFileChooser.APPROVE_OPTION:
                // fil vald
                verktygsradLoggfil.setText(filvljare.getSelectedFile().getAbsolutePath());
                // ladda in
                loggfilen.setSkvg(filvljare.getSelectedFile().getAbsolutePath());
                if (loggfilen.laddaLoggfil()) {
                    ((LoggfilTableModel) tabell1.getModel()).fireTableDataChanged();
                    uppdateraStatus();
                    verktygsradUppdatera.setEnabled(true);
                    menyFilUppdatera.setEnabled(true);
                    packaKolumner();
                    skapaStatistik();
                    filtreraTabell();
                } else {
                    uppdateraStatus();
                    skapaStatistik();
                    verktygsradLoggfil.setText( "Could not load \"" + loggfilen.getSkvg() + "\"" );
                    verktygsradUppdatera.setEnabled(false);
                    menyFilUppdatera.setEnabled(false);
                    JOptionPane.showMessageDialog(this, "Log file could not be loaded.\nError message:\n\n" + loggfilen.getLastError(), "Error", JOptionPane.ERROR_MESSAGE);
                }
                break;
        } // switch
        
        setCursor( new Cursor(Cursor.DEFAULT_CURSOR));
    }
    
    /**
     * Laddar om loggfilen och uppdaterar tabellen
     */
    public void laddaOmFilen() {
        
        setCursor( new Cursor(Cursor.WAIT_CURSOR));
        
        // ladda bara om filen
        if (loggfilen.laddaLoggfil()) {
            ((LoggfilTableModel) tabell1.getModel()).fireTableDataChanged();
            uppdateraStatus();
            packaKolumner();
            skapaStatistik();
            filtreraTabell();
        } else {
            uppdateraStatus();
            skapaStatistik();
            verktygsradLoggfil.setText( "Could not load \"" + loggfilen.getSkvg() + "\"" );
            verktygsradUppdatera.setEnabled(false);
            menyFilUppdatera.setEnabled(false);
            JOptionPane.showMessageDialog(this, "Log file could not be loaded.\nError message:\n\n" + loggfilen.getLastError(), "Error", JOptionPane.ERROR_MESSAGE);
        }
        
        setCursor( new Cursor(Cursor.DEFAULT_CURSOR));
        
    }
    
    /**
     * Frgar om anvndaren vill avsluta programmet och avslutet det om anvndaren svarar ja p frgan.
     */
    public void avsluta() {
        switch ( JOptionPane.showConfirmDialog(this, "Quit " + PROGRAMNAMN + "?", "Quit", JOptionPane.YES_NO_OPTION) ) {
            case 0:
                System.exit(0);
        }
    }
    
    
    /**
     * Sorterar en kolumn
     * @param kolumn nummer p kolumn som ska sorteras
     */
    public void sorteraKolumn(int kolumn) {
        
        String s;
        // hmta kolumnens namn
        TableColumn tc;
        tc = tabell1.getColumnModel().getColumn(kolumn);
        s = (String) tc.getHeaderValue();
        
        // avgr om denna kolumn redan r sorterad och t vilket hll isf
        // kolumner som r sorterade slutar p "v" eller "^"
        if (s.endsWith(" v")) {
            // redan sorterad v
            s = s.substring(0, s.length()-1) + "^";
            sortAllRowsBy( (LoggfilTableModel) tabell1.getModel(), kolumn, false );
        } else if (s.endsWith(" ^")) {
            // redan sorterad ^
            s = s.substring(0, s.length()-1) + "v";
            sortAllRowsBy( (LoggfilTableModel) tabell1.getModel(), kolumn, true );
        } else {
            // inte sorterad
            s = s + " v";
            sortAllRowsBy( (LoggfilTableModel) tabell1.getModel(), kolumn, true );
        }
        
        // nollstll rubriken p alla kolumner innan vi skriver nytt vrde
        // den gamla sorterings"pilen" ligger kvar annars
        TableColumn t;
        String ts;
        for (int i = 0; i < tabell1.getColumnCount(); i++) {
            t = tabell1.getColumnModel().getColumn(i);
            // bara nollstlla om rubriken slutar p v eller ^
            if (((String)t.getHeaderValue()).endsWith(" v") || ((String)t.getHeaderValue()).endsWith(" ^")) {
                ts = (String) t.getHeaderValue();
                t.setHeaderValue( ts.substring(0, ts.length()-2) );
            }
        }
        tc.setHeaderValue(s);
        //  s dumt, men det funkar
        // fr att rita om kolumnnamnen s kar jag storleken med en pixel och flyttar tillaka en pixel
        // finns nt grymt mycket smartare stt, men nn fire*pryl hittar jag d inte iaf
        tc.setPreferredWidth( tc.getPreferredWidth()+1 );
        tc.setPreferredWidth( tc.getPreferredWidth()-1 );
        
    }
    
    /**
     * Skapar/Bygger ihop statistiken
     */
    public void skapaStatistik() {
        TreeMap tDstPort = new TreeMap();
        TreeMap tSrcPort = new TreeMap();
        TreeMap tSrcIP = new TreeMap();
        TreeMap tDstIP = new TreeMap();
        Integer nyckelDstPort;
        Integer nyckelSrcPort;
        String nyckelSrcIP;
        String nyckelDstIP;
        
        Integer antal;
        Integer nyckel;
        Loggfilsrad rad;
        Integer nyttAntal;
        
        // fr varje rad i loggfilen
        for (int i = 0; i < loggfilen.getAntalRader(); i++) {
            
            // hmta en rad
            rad = loggfilen.getRad(i);
            
            // fljande r ju s korkat det bara kan bli, borde ligga i generell metod :(
            
            // hmta vrden frn rad
            nyckelDstPort = rad.getDstport();
            nyckelSrcPort = rad.getSrcport();
            nyckelSrcIP = rad.getSrcip();
            nyckelDstIP = rad.getDstip();
            
            // DstPort
            if (tDstPort.containsKey(nyckelDstPort)) {
                nyttAntal = new Integer(((Integer) tDstPort.get(nyckelDstPort)).intValue() + 1);
                tDstPort.put(nyckelDstPort, nyttAntal );
            } else {
                tDstPort.put(nyckelDstPort, new Integer(1));
            }
            // SrcPort
            if (tSrcPort.containsKey(nyckelSrcPort)) {
                nyttAntal = new Integer(((Integer) tSrcPort.get(nyckelSrcPort)).intValue() + 1);
                tSrcPort.put(nyckelSrcPort, nyttAntal );
            } else {
                tSrcPort.put(nyckelSrcPort, new Integer(1));
            }
            // SrcIP
            if (tSrcIP.containsKey(nyckelSrcIP)) {
                nyttAntal = new Integer(((Integer) tSrcIP.get(nyckelSrcIP)).intValue() + 1);
                tSrcIP.put(nyckelSrcIP, nyttAntal );
            } else {
                tSrcIP.put(nyckelSrcIP, new Integer(1));
            }
            // DstIP
            if (tDstIP.containsKey(nyckelDstIP)) {
                nyttAntal = new Integer(((Integer) tDstIP.get(nyckelDstIP)).intValue() + 1);
                tDstIP.put(nyckelDstIP, nyttAntal );
            } else {
                tDstIP.put(nyckelDstIP, new Integer(1));
            }
            
        } // for
        
        skapaStatistikTabell("No.", "Source IP", tSrcIP.entrySet(), tabbarTab2Tabell1);
        skapaStatistikTabell("No.", "Destination IP", tDstIP.entrySet(), tabbarTab2Tabell2);
        skapaStatistikTabell("No.", "Source port", tSrcPort.entrySet(), tabbarTab2Tabell3);
        skapaStatistikTabell("No.", "Destination Port", tDstPort.entrySet(), tabbarTab2Tabell4);
        
        
    }
    
    /** Skapar en statistiktabell
     * @param kolumnnamn1 Namn p frsta kolumnen i tabellen
     * @param kolumnnamn2 Namn p andra kolumnen i tabellen
     * @param sEntrys Nn tree-map-ptryls-grej
     * @param tillTabell Tabell som allt ska till
     */
    public void skapaStatistikTabell(String kolumnnamn1, String kolumnnamn2, Set sEntrys, JTable tillTabell) {
        
        // nu mste vi sortera skrllet p nt vis
        // hm.. kanske bara in med dom i en tabell och kra sorteringen p dom?
        Vector vKolumner = new Vector();
        vKolumner.add(kolumnnamn1); vKolumner.add(kolumnnamn2);
        Vector v1 = new Vector();
        Iterator iteratorn = sEntrys.iterator();
        Map.Entry e;
        
        while (iteratorn.hasNext()) {
            e = (Map.Entry) iteratorn.next();
            Vector v2 = new Vector();
            v1.add(v2);
            v2.add(e.getValue()); v2.add(e.getKey());
            
        }
        
        tillTabell.setModel(new LoggfilStatistikTableModel( v1, vKolumner ));
        sorteraStatistikTabell((DefaultTableModel) tillTabell.getModel(), 0, false);
        tillTabell.getColumnModel().getColumn(0).setMaxWidth(50);
        
    }
    
    /** Filtrerar tabellen baserat p vad som r inskrivet av anvndare */
    public void filtreraTabell() {
        
        setCursor( new Cursor(Cursor.WAIT_CURSOR));
        
        String filter;
        filter = tabbarTab1InfoPanelTxtFiltrera.getText();
        
        // avgr om knappen r nere eller uppe
        if (tabbarTab1InfoPanelBtnFiltrera.isSelected()) {
            ((LoggfilTableModel) tabell1.getModel()).filtreraVektor(filter, tabbarTab1InfoPanelRadioAnd.isSelected());
        } else {
            ((LoggfilTableModel) tabell1.getModel()).stoppaFiltreringAvVektor();
        }
        
        setCursor( new Cursor(Cursor.DEFAULT_CURSOR) ) ;
    }
    
    /** Kollar om anvndaren tryckt p enter/return, fr d ska filtreringen aktiveras
     * @param e KeyEvent
     */
    public void keyPressed(KeyEvent e) {
        // man fr vl anta att om man trycker p return s vill man att tabellen ska fitreras
        if (e.getKeyChar() == '\n') {
            tabbarTab1InfoPanelBtnFiltrera.setSelected(true);
            filtreraTabell();
        }
    }
    
    /** Anvnds inte
     * @param e KeyEvent
     */
    public void keyReleased(KeyEvent e) {    }
    
    /** Anvnds inte
     * @param e KeyEvent e
     */
    public void keyTyped(KeyEvent e) {    }
    
}
