import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.awt.*;

class LoggfilTableModel extends AbstractTableModel {
    
    Loggfil loggen;
    Loggfilsrad rad;
    Vector vData = new Vector(); // detta ska vara vectorn av vectorer
    Date loggdatum;
    int antalBortfiltreradeRader = 0;
    boolean rFiltrerad = false;
    
    /**
     * Filtera datavektorn s att endast de ord som finns i sFilter visas i tabellen
     * @ param sFilter ett eller flera ord (nummer) separerade med mellanslag
     * @ param allaOrd True om alla ord i sFilter mste vara med i en rad fr att den ska visas. False om det rcker med att ngon av orden i sFilter r med fr att raden ska visas
     */
    public void filtreraVektor(String sFilter, boolean allaOrd) {
        
        // vid varje filtrering mste vi ha allt material frn loggfilena att brja med
        // vid andra filtreringen finns ju annars inte allt material
        skapaVektor();
        
        int antalOrdtrffar = 0; // hur mnga av orden i sFilter som ger trff p en rad. anvnds fr att kolla om alla ord trffats p i en rad
        
        StringTokenizer st = new StringTokenizer(sFilter.toLowerCase());
        String[] filtreringsOrd = new String[ st.countTokens() ];
        for (int i=0; i<filtreringsOrd.length; i++) {
            filtreringsOrd[i] = st.nextToken();
        }
        
        // fr varje rad i vData
        antalBortfiltreradeRader = 0;
        Vector vRad;
        Iterator iteratorn = vData.iterator();
        Iterator iteratorn2;
        Object oElementIRad;
        boolean isFound = false;
        
        while (iteratorn.hasNext()) {
            
            vRad = (Vector) iteratorn.next();
            // fr varje element i vRad
            iteratorn2 = vRad.iterator();
            isFound = false;
            antalOrdtrffar = 0;
            
            loop1: while (iteratorn2.hasNext()) {
                // det som sker hr inne r allts per rad i vRad...hum.. yeah!
                oElementIRad = iteratorn2.next();
                
                for (int j=0; j<filtreringsOrd.length; j++) { // fr varje filtreringsord
                    
                    if (oElementIRad instanceof Integer) {
                        if (((Integer) oElementIRad).toString().toLowerCase().indexOf(filtreringsOrd[j]) >= 0 ) {
                            isFound = true;
                            antalOrdtrffar++;
                            //break loop1;
                        }
                    } else if (oElementIRad instanceof String) {
                        if ( ((String)oElementIRad).toLowerCase().indexOf(filtreringsOrd[j]) >= 0 ) {
                            isFound = true;
                            antalOrdtrffar++;
                            //break loop1;
                        }
                    }
                } // for filt.ord
                
            } // while iteratorn2
            
            if (allaOrd) {
                // alla ord mste vara med
                if (antalOrdtrffar < filtreringsOrd.length) {
                    // alla ord ptrffade p denna rad
                    iteratorn.remove();
                    antalBortfiltreradeRader++;
                }
            } else {
                // rcker med ett ord
                if (antalOrdtrffar < 1) {
                    // alla ord ptrffade p denna rad
                    iteratorn.remove();
                    antalBortfiltreradeRader++;
                }
                
            }
            
        } // while
        
        fireTableDataChanged();
        rFiltrerad = true;
    }
    
    /**
     * Skapar vectorn av vectorer
     */
    private void skapaVektor() {
        
        rFiltrerad = false;
        
        // var s hr jag borde gjort frn brjan istllet fr att kra loggen.getRad...fr varje getValue-anrop
        loggdatum = loggen.getDatumInlst();
        
        Loggfilsrad loggrad;
        Vector vRad;
        
        vData.clear();
        
        // fr varje rad i loggfilen...
        for (int i = 0; i < loggen.getAntalRader(); i++) {
            
            vRad = new Vector(); // vector som ska lggas till i vData
            loggrad = loggen.getRad(i);
            
            vRad.add( new Integer(i) );
            vRad.add( loggrad.getDatum() );
            vRad.add( loggrad.getAction() );
            vRad.add( loggrad.getProtocol() );
            vRad.add( loggrad.getSrcip() );
            vRad.add( loggrad.getDstip() );
            vRad.add( loggrad.getSrcport() );
            vRad.add( loggrad.getDstport() );
            vRad.add( loggrad.getSize() );
            vRad.add( loggrad.getTcpflags() );
            vRad.add( loggrad.getTcpsyn() );
            vRad.add( loggrad.getTcpack() );
            vRad.add( loggrad.getTcpwin() );
            vRad.add( loggrad.getIcmptype() );
            vRad.add( loggrad.getIcmpcode() );
            vRad.add( loggrad.getInfo() );
            vRad.add( loggrad.getPath() );
            
            // lgg till vectorn i vectorn
            vData.add(vRad);
            
        } // for j
        
    }

    /**
     * Konstruktor som tar emot en Loggfil
     * Denna konstruktor ska anvndas!
     * @param l Loggfilsobjekt
     */
    LoggfilTableModel(Loggfil l) {
        loggen = l;
        //     skapaVektor();
    }
    
    /**
     * Ger antalet kolumner
     * @ return Antal kolumner
     */
    public int getColumnCount() {
        
        return 17;
        
    }
    
    public int getRowCount() {
        // returnera antal rader beroende p om loggen r filtrerad eller inte
        if (rFiltrerad) {
            return loggen.getAntalRader() - antalBortfiltreradeRader;
        } else {
            return loggen.getAntalRader();
        }
        //return vData.size();
    }
    
    /**
     * Mste finnas fr sorteringen...
     */
    public Vector getDataVector() {
        return vData;
    }
    
    public Object getValueAt(int rowIndex, int columnIndex) {
        
        // det hr bli ju jvligt knppt va, men jag mste ju ha koll
        // p om loggfilen laddats om osv.
        // s.. om denna model och loggfilen har samma datum satt s ska inget gras, annars ladda om allt.
        if (loggdatum != loggen.getDatumInlst()) {
            // loggen har lsts in p nytt, uppdatera
            skapaVektor();
        }
        
        return  ((Vector) vData.get(rowIndex)).get(columnIndex);
        
    }

    public void stoppaFiltreringAvVektor() {        
        skapaVektor();
        rFiltrerad = false;
        fireTableDataChanged();
        
    }
    
    
    
    
    /*
     // GAMLA getValueAt
     // ersattes med vector av vectorer-prylen fr att sorteringen skulle funka
     // (annars s funkade faktiskt denna)
    public Object getValueAt(int rowIndex, int columnIndex) {
     
        // hmta en rad frst d
        rad = loggen.getRad(rowIndex);
     
        // mje, hmta en viss column
        switch (columnIndex) {
            case 0: return Integer.toString(rowIndex);
            case 1: return rad.getDatum();
            case 2: return rad.getAction();
            case 3: return rad.getProtocol();
            case 4: return rad.getSrcip();
            case 5: return rad.getDstip();
            case 6: return rad.getSrcport();
            case 7: return rad.getDstport();
            case 8: return rad.getSize();
            case 9: return rad.getTcpflags();
            case 10: return rad.getTcpsyn();
            case 11: return rad.getTcpack();
            case 12: return rad.getTcpwin();
            case 13: return rad.getIcmptype();
            case 14: return rad.getIcmpcode();
            case 15: return rad.getInfo();
            default: return "Unknown columnIndex";
        }
     
     
     
//0 radnummer
//1     private Date   datum;
//2     private String action;
//3     private String protocol;
//4     private String srcip;
//5     private String dstip;
//6     private String srcport;
//7     private String dstport;
//8     private String size;
//9     private String tcpflags;
//10    private String tcpsyn;
//11    private String tcpack;
//12    private String tcpwin;
//13    private String icmptype;
//14    private String icmpcode;
//15    private String info;
//16    path;
     
     
     
    }
     */
}
